<?php 

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2013, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		revolutionslider
 * @link		http://contao.org
 */

/**
 * Load language file
 */
$this->loadLanguageFile('tl_module');
$this->loadLanguageFile('tl_content');

/**
 * Table tl_revolutionslider
 */
$GLOBALS['TL_DCA']['tl_revolutionslider'] = array
(
	// Config
	'config' => array
	(
		'dataContainer'               => 'Table',
		'ctable'                      => array('tl_revolutionslider_slides'),
		'switchToEdit'                => true,
		'enableVersioning'            => true,
		'onload_callback' => array
		(
			array('RevolutionSlider\Backend\TableRevolutionSlider', 'modifyPalettes'),
			array('RevolutionSlider\Backend\TableRevolutionSlider', 'checkPermission'),
		),
		'sql' => array
		(
			'keys' => array
			(
				'id' => 'primary',
				'pid' => 'index',
				'tstamp' => 'index'
			)
		)
	),
	// List
	'list' => array
	(
		'sorting' => array
		(
			'mode'                    => 1,
			'fields'                  => array('title'),
			'flag'                    => 1,
			'panelLayout'             => 'filter;search,limit'
		),
		'label' => array
		(
			'fields'                  => array('title'),
			'format'                  => '%s'
		),
		'global_operations' => array
		(
			'all' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['MSC']['all'],
				'href'                => 'act=select',
				'class'               => 'header_edit_all',
				'attributes'          => 'onclick="Backend.getScrollOffset()" accesskey="e"'
			),
		),
		'operations' => array
		(
			'edit' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider']['edit'],
				'href'                => 'table=tl_revolutionslider_slides',
				'icon'                => 'edit.gif',
			),
			'editheader' => array
			(
			   'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider']['edit'],
			   'href'                => 'act=edit',
			   'icon'                => 'system/modules/revolutionslider/assets/img/header.gif',
			   'button_callback'     => array('RevolutionSlider\Backend\TableRevolutionSlider', 'editHeader'),
			),
			'copy' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider']['copy'],
				'href'                => 'act=copy',
				'icon'                => 'copy.gif',
				'button_callback'     => array('RevolutionSlider\Backend\TableRevolutionSlider', 'copyButton')
			),
			'delete' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider']['delete'],
				'href'                => 'act=delete',
				'icon'                => 'delete.gif',
				'attributes'          => 'onclick="if(!confirm(\'' . $GLOBALS['TL_LANG']['MSC']['deleteConfirm'] . '\'))return false;Backend.getScrollOffset()"',
				'button_callback'     => array('RevolutionSlider\Backend\TableRevolutionSlider', 'deleteButton')
			),
			'show' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider']['show'],
				'href'                => 'act=show',
				'icon'                => 'show.gif'
			),
		)
	),
	
	// Palettes
	'palettes' => array
	(
		'__selector__'				  => array('addThumbs','addNavigation','addArrows'),
		'default'                  	  => '{title_legend},title;{settings_legend},sliderStyle,sliderSize,transition,delay;{navigation_legend},addNavigation,addArrows,stopOnHover;{thumbnail_legend},addThumbs;{template_legend},sliderTemplate,jsTemplate;{expert_legend:hide},cssID;'
	),
	// Subpalettes
	'subpalettes' => array
	(
		'addThumbs'					  => 'thumbSize,thumbAmount',
		'addNavigation'				  => 'navigationType,navigationStyle',
		'addArrows'					  => 'arrowStyle'
	),
	// Fields
	'fields' => array
	(
		'id' => array
		(
			'eval'					  => array('doNotCopy'=>true),
			'sql'                     => "int(10) unsigned NOT NULL auto_increment",
		),
		'pid' => array
		(
			'eval'					  => array('doNotCopy'=>true),
			'sql'                     => "int(10) unsigned NOT NULL default '0'",
		),
		'tstamp' => array
		(
			'eval'					  => array('doNotCopy'=>true),
			'sql'                     => "int(10) unsigned NOT NULL default '0'",
		),
		'source' => array
		(
			'eval'					  => array('doNotCopy'=>true),
			'sql'                     => "varchar(32) NOT NULL default ''",
		),
		'title' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['title'],
			'exclude'                 => true,
			'search'                  => true,
			'inputType'               => 'text',
			'eval'                    => array('mandatory'=>true, 'maxlength'=>255, 'tl_class'=>''),
			'sql'					  =>  "varchar(255) NOT NULL default ''",
		),
		'cssID' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_module']['cssID'],
			'exclude'                 => true,
			'inputType'               => 'text',
			'eval'                    => array('multiple'=>true, 'size'=>2, 'tl_class'=>'w50'),
			'sql'					  =>  "varchar(255) NOT NULL default ''",
		),
		'sliderStyle' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['sliderStyle'],
			'exclude'                 => true,
			'inputType'               => 'select',
			'default'				  => 'responsive',
			'options'				  => array('responsive','fullwidth','simple'),
			'reference'               => &$GLOBALS['TL_LANG']['tl_revolutionslider']['sliderStyle'],
			'eval'                    => array('tl_class'=>'w50'),
			'sql'					  =>  "varchar(64) NOT NULL default ''",
		),
		'sliderSize' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['sliderSize'],
			'exclude'                 => true,
			'inputType'               => 'text',
			'eval'                    => array('multiple'=>true, 'size'=>2, 'tl_class'=>'w50','mandatory'=>true),
			'sql'					  =>  "varchar(255) NOT NULL default ''",
		),
		'transition' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['transition'],
			'exclude'                 => true,
			'inputType'               => 'select',
			'default'				  => 'fade',
			'options_callback'		  => array('RevolutionSlider\Core\RevolutionSlider', 'getTransitions'),
			'eval'                    => array('tl_class'=>'clr','chosen'=>true),
			'sql'					  =>  "varchar(64) NOT NULL default ''",
		),
		'delay' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['delay'],
			'exclude'                 => true,
			'inputType'               => 'text',
			'default'				  => 4,
			'eval'                    => array('tl_class'=>'clr'),
			'sql'					  =>  "varchar(16) NOT NULL default '4'",
		),
		
		'addNavigation' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['addNavigation'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'eval'                    => array('submitOnChange'=>true,'tl_class'=>'clr'),
			'sql'					  =>  "char(1) NOT NULL default ''",
		),
		'navigationType' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['navigationType'],
			'exclude'                 => true,
			'inputType'               => 'select',
			'options'				  => array('bullet'),
			'reference'               => &$GLOBALS['TL_LANG']['tl_revolutionslider']['navigationType'],
			'eval'                    => array('insertBlankOption'=>true,'tl_class'=>'w50'),
			'sql'					  =>  "varchar(64) NOT NULL default ''",
		),
		'navigationStyle' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['navigationStyle'],
			'exclude'                 => true,
			'inputType'               => 'select',
			'options'				  => array('round','square','round-old','square-old','navbar','navbar-old'),
			'reference'               => &$GLOBALS['TL_LANG']['tl_revolutionslider']['navigationStyle'],
			'eval'                    => array('insertBlankOption'=>true,'tl_class'=>'w50'),
			'sql'					  =>  "varchar(64) NOT NULL default ''",
		),
		'addArrows' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['addArrows'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'eval'                    => array('submitOnChange'=>true,'tl_class'=>'clr'),
			'sql'					  =>  "char(1) NOT NULL default ''",
		),
		'arrowStyle' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['arrowStyle'],
			'exclude'                 => true,
			'inputType'               => 'select',
			'options'				  => array('nexttobullets', 'solo'),
			'reference'               => &$GLOBALS['TL_LANG']['tl_revolutionslider']['navigationStyle'],
			'eval'                    => array('insertBlankOption'=>true,'tl_class'=>'clr'),
			'sql'					  =>  "varchar(64) NOT NULL default ''",
		),
		'stopOnHover' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['stopOnHover'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'eval'                    => array('tl_class'=>'clr'),
			'sql'					  =>  "char(1) NOT NULL default '1'",
		),
		
		
		'addThumbs' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['addThumbs'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'eval'                    => array('submitOnChange'=>true,'tl_class'=>'clr'),
			'sql'					  =>  "char(1) NOT NULL default ''",
		),
		'thumbSize' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['thumbSize'],
			'exclude'                 => true,
			'inputType'               => 'imageSize',
			'options'                 => $GLOBALS['TL_CROP'],
			'reference'               => &$GLOBALS['TL_LANG']['MSC'],
			'eval'                    => array('rgxp'=>'digit', 'nospace'=>true, 'helpwizard'=>true, 'tl_class'=>'w50'),
			'sql'					  =>  "varchar(255) NOT NULL default ''",
		),
		'thumbAmount' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['thumbAmount'],
			'exclude'                 => true,
			'inputType'               => 'text',
			'default'				  => 3,
			'eval'                    => array('rgxp'=>'num', 'tl_class'=>'w50'),
			'sql'					  =>  "char(4) NOT NULL default '3'",
		),
		
		'sliderTemplate' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['sliderTemplate'],
			'exclude'                 => true,
			'inputType'               => 'select',
			'options_callback'        => array('RevolutionSlider\Backend\TableRevolutionSlider', 'getSliderTemplates'),
			'eval'                    => array('tl_class'=>'w50'),
			'sql'					  => "varchar(64) NOT NULL default ''",
		),
		'jsTemplate' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['jsTemplate'],
			'exclude'                 => true,
			'inputType'               => 'select',
			'options_callback'        => array('RevolutionSlider\Backend\TableRevolutionSlider', 'getJsTemplates'),
			'eval'                    => array('tl_class'=>'w50'),
			'sql'					  => "varchar(64) NOT NULL default ''",
		),
	)
);
