<?php 

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2013, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		revolutionslider
 * @link		http://contao.org
 */

/**
 * Load language file
 */
$this->loadLanguageFile('tl_module');
$this->loadLanguageFile('tl_content');
$this->loadLanguageFile('tl_revolutionslider');

/**
 * Load data containers
 */
$this->loadDataContainer('tl_content');

/**
 * Table tl_revolutionslider_slides
 */
$GLOBALS['TL_DCA']['tl_revolutionslider_slides'] = array
(
	// Config
	'config' => array
	(
		'dataContainer'               => 'Table',
		'ptable'                      => 'tl_revolutionslider',
		'ctable'                      => array('tl_content'),
		'switchToEdit'                => true,
		'enableVersioning'            => true,
		'onload_callback'			=> array
		(
			array('RevolutionSlider\Backend\TableRevolutionSliderSlides', 'loadStyles'),
			array('RevolutionSlider\Backend\TableRevolutionSliderSlides', 'checkPermission'),
		),
		'sql' => array
		(
			'keys' => array
			(
				'id' => 'primary',
				'pid' => 'index',
			)
		)
	),
	// List
	'list' => array
	(
		'sorting' => array
		(
			'mode'                    => 4,
			'fields'                  => array('sorting'),
			'headerFields'            => array('title'),
			'panelLayout'             => 'search,limit',
			'child_record_callback'   => array('RevolutionSlider\Backend\TableRevolutionSliderSlides', 'listSlides'),
		),
		'label' => array
		(
			'fields'                  => array('title'),
			'format'                  => '%s'
		),
		'global_operations' => array
		(
			'all' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['MSC']['all'],
				'href'                => 'act=select',
				'class'               => 'header_edit_all',
				'attributes'          => 'onclick="Backend.getScrollOffset()" accesskey="e"'
			),
		),
		'operations' => array
		(
			'edit' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['edit'],
				'href'                => 'table=tl_content&mode=2',
				'icon'                => 'edit.gif',
				#'button_callback'     => array('TableRevolutionSliderSlides', 'edit'),
			),
			'editheader' => array
			(
			   'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['editheader'],
			   'href'                => 'act=edit',
			   'icon'                => 'system/modules/revolutionslider/assets/img/header.gif',
			   'button_callback'     => array('RevolutionSlider\Backend\TableRevolutionSliderSlides', 'editHeader'),
			),
			'copy' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['copy'],
				'href'                => 'act=paste&amp;mode=copy',
				'icon'                => 'copy.gif',
				'button_callback'     => array('RevolutionSlider\Backend\TableRevolutionSliderSlides', 'copyButton'),
			),
			'cut' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['cut'],
				'href'                => 'act=paste&amp;mode=cut',
				'icon'                => 'cut.gif',
				'button_callback'     => array('RevolutionSlider\Backend\TableRevolutionSliderSlides', 'cutButton'),
			),
			'delete' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['delete'],
				'href'                => 'act=delete',
				'icon'                => 'delete.gif',
				'attributes'          => 'onclick="if(!confirm(\'' . $GLOBALS['TL_LANG']['MSC']['deleteConfirm'] . '\'))return false;Backend.getScrollOffset()"',
				'button_callback'     => array('RevolutionSlider\Backend\TableRevolutionSliderSlides', 'deleteButton'),
			),
			'toggle' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['toggle'],
				'icon'                => 'visible.gif',
				'attributes'          => 'onclick="Backend.getScrollOffset();return AjaxRequest.toggleVisibility(this,%s)"',
				'button_callback'     => array('RevolutionSlider\Backend\TableRevolutionSliderSlides', 'toggleIcon')
			),
			'show' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['show'],
				'href'                => 'act=show',
				'icon'                => 'show.gif'
			),
		)
	),
	
	// Palettes
	'palettes' => array
	(
		'__selector__'				=> array(),
		'default'                    => '{title_legend},title;{settings_legend},transition,slideUrl,newWindow,singleSRC;{expert_settings_legend:hide},slotamount,masterspeed,delay,singleSRC_thumb,lazyload;{expert_legend:hide},cssID,published;'
	),
	// Subpalettes
	'subpalettes' => array
	(
	
	),
	// Fields
	'fields' => array
	(
		'id' => array
		(
			'sql'                     => "int(10) unsigned NOT NULL auto_increment",
		),
		'pid' => array
		(
			'sql'                     => "int(10) unsigned NOT NULL default '0'",
		),
		'sorting' => array
		(
			'sql'                     => "int(10) unsigned NOT NULL default '0'",
		),
		'tstamp' => array
		(
			'sql'                     => "int(10) unsigned NOT NULL default '0'",
		),
		'title' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider']['title'],
			'exclude'                 => true,
			'search'                  => true,
			'inputType'               => 'text',
			'eval'                    => array('mandatory'=>true, 'maxlength'=>255, 'tl_class'=>''),
			'sql'					  =>  "varchar(255) NOT NULL default ''",
		),
		'transition' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['transition'],
			'exclude'                 => true,
			'inputType'               => 'select',
			'default'				  => 'fade',
			'options_callback'		  => array('RevolutionSlider\Core\RevolutionSlider', 'getTransitions'),
			'eval'                    => array('includeBlankOption'=>true,'tl_class'=>'','chosen'=>true),
			'sql'					  =>  "varchar(64) NOT NULL default ''",
		),
		'slideUrl' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['slideUrl'],
			'exclude'                 => true,
			'inputType'               => 'text',
			'eval'                    => array('rgxp'=>'url', 'decodeEntities'=>true, 'maxlength'=>255,'tl_class'=>'w50 wizard'),
			'wizard' => array
			(
				array('RevolutionSlider\Backend\TableRevolutionSliderSlides', 'pagePicker')
			),
			'sql'					  =>  "varchar(255) NOT NULL default ''",
		),
		'newWindow' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['newWindow'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'eval'                    => array('tl_class'=>'w50 m12'),
			'sql'					  =>  "char(1) NOT NULL default ''",
		),
		'slotamount' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['slotamount'],
			'exclude'                 => true,
			'inputType'               => 'select',
			'default'				  => 4,
			'options'				  => array(1,2,3,4,5,6,7,8,9,10,15),
			'eval'                    => array('tl_class'=>''),
			'sql'					  =>  "varchar(16) NOT NULL default ''",
		),
		'masterspeed' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['masterspeed'],
			'exclude'                 => true,
			'inputType'               => 'text',
			'default'				  => '0.03',
			'eval'                    => array('tl_class'=>''),
			'sql'					  =>  "varchar(16) NOT NULL default ''",
		),
		'delay' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['delay'],
			'exclude'                 => true,
			'inputType'               => 'text',
			'eval'                    => array('tl_class'=>''),
			'sql'					  =>  "varchar(16) NOT NULL default ''",
		),
		'lazyload' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['lazyload'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'eval'                    => array('tl_class'=>''),
			'sql'					  =>  "char(1) NOT NULL default ''",
		),
		'singleSRC_thumb' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['singleSRC_thumb'],
			'exclude'                 => true,
			'inputType'               => 'fileTree',
			'eval'                    => array('fieldType'=>'radio', 'files'=>true, 'tl_class'=>'clr'),
			'save_callback' => array
			(
				array('tl_content', 'storeFileMetaInformation')
			),
			'sql'					  =>  "binary(16) NULL",
		),
		
		'singleSRC' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['singleSRC'],
			'exclude'                 => true,
			'inputType'               => 'fileTree',
			'eval'                    => array('fieldType'=>'radio', 'files'=>true, 'tl_class'=>'clr'),
			'save_callback' => array
			(
				array('tl_content', 'storeFileMetaInformation')
			),
			'sql'					  =>  "binary(16) NULL",
		),
		'cssID' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_module']['cssID'],
			'exclude'                 => true,
			'inputType'               => 'text',
			'eval'                    => array('multiple'=>true, 'size'=>2, 'tl_class'=>'w50'),
			'sql'					  =>  "varchar(255) NOT NULL default ''",
		),
		'published' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_revolutionslider_slides']['published'],
			'exclude'                 => true,
			'filter'                  => true,
			'flag'                    => 1,
			'inputType'               => 'checkbox',
			'eval'                    => array('tl_class'=>'clr','doNotCopy'=>true),
			'sql'                     => "char(1) NOT NULL default ''"
		),
	)
);


/**
 * Backwards compatibility to < 3.2
 */
if(version_compare(VERSION, '3.2', '<'))
{
	$GLOBALS['TL_DCA']['tl_revolutionslider_slides']['fields']['singleSRC']['sql'] = "varchar(255) NOT NULL default ''";
	$GLOBALS['TL_DCA']['tl_revolutionslider_slides']['fields']['singleSRC_thumb']['sql'] = "varchar(255) NOT NULL default ''";
}
