<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2013
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		revolutionslider
 * @link		http://contao.org
 * @license		http://www.gnu.org/licenses/lgpl-3.0.html LGPL
 */

/**
 * Namespace
 */
namespace RevolutionSlider\Backend;

/**
 * Class file
 * TableUserGroups
 * Provide methods for table tl_user_groups
 */
class TableUserGroup extends \Backend
{	
	/**
	 * Import the back end user object
	 */
	public function __construct()
	{
		parent::__construct();
		$this->import('BackendUser','User');
	}
	
	/**
	 * Get all slides of the current slider an return as array
	 * @param object
	 * @return array
	 */
	public function getSlides(\DataContainer $objDC)
	{
		$objDatabase = \Database::getInstance();
		
		$arrSlider = deserialize($objDC->activeRecord->revolutionsliders);
		
		if(!$objDC->activeRecord->revolutionsliders || empty($arrSlider))
		{
			return array();
		}
		
		$objSlides = $objDatabase->prepare("SELECT * FROM tl_revolutionslider_slides WHERE pid IN(".implode(',',$arrSlider).") ORDER BY sorting,pid")->execute();
		
		if($objSlides->numRows < 1)
		{
			return array();
		}
		
		$arrReturn = array();
		while($objSlides->next())
		{
			$objSlider = $objDatabase->prepare("SELECT id,title FROM tl_revolutionslider WHERE id=?")->limit(1)->execute($objSlides->pid);
			
			$strLabel = $objSlider->title . ' >> ' . $objSlides->title . ' (id:' .$objSlides->id.')';
			$arrReturn[$objSlides->id] = $strLabel;
		}
		
		return $arrReturn;
	}
	
}
