<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2013, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		revolutionslider
 * @link		http://contao.org
 */


/**

Inserttags

{{revolutionslider::*}}
{{revoslider::*}}

*/

/**
 * Namespace
 */
namespace RevolutionSlider\Core;

/**
 * Imports
 */
use RevolutionSlider\Core\Factory as SliderFactory;

/**
 * Class file
 * Replace inserttags
 */
class InsertTags extends \Controller
{
	/**
	 * Replace RevolutionSlider related inserttags
	 *
	 * @param string
	 * @return mixed
	 */
	public function replaceTags($strTag)
	{
		$arrElements = explode('::', $strTag);
		
		switch($arrElements[0])
		{
			// Render the slider and return html
			case 'revolutionslider': 
			case 'revoslider':
				$objSlider = SliderFactory::byId($arrElements[1]);		
				
				// return if slider is obsolete
				if(!$objSlider)
				{
					return false;
				}
				
				// mimic a content element, makes it easier with all the wrapping divs
				$objTemplate = new \FrontendTemplate('ce_revolutionslider');
				$objTemplate->class = 'revolutionslider';
				$arrCssID = deserialize($objSlider->get('cssID'));
		
				$arrClass = explode(' ',$arrCssID[1]);
				$arrClass[] = $objSlider->get('sliderStyle');
				
				$objTemplate->sliderClass = implode(' ', $arrClass);
				$objTemplate->slider = $objSlider->render();
				
				return $objTemplate->parse();
			
				break;
			default:
				return false;
				break;
		}
	}

}