<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2013, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		revolutionslider
 * @link		http://contao.org
 */

/**
 * Namespaces
 */
namespace RevolutionSlider\Frontend;

/**
 * Class file
 * ContentRevolutionSlider
 */
class ContentRevolutionSlider extends \ContentElement
{
	/**
	 * Template
	 * @var
	 */
	protected $strTemplate = 'ce_revolutionslider';
	
	/**
	 * Display wildcard
	 */
	public function generate()
	{
		if (TL_MODE == 'BE')
		{
			$objDatabase = \Database::getInstance();
			$objResult = $objDatabase->prepare("SELECT * FROM tl_revolutionslider WHERE id=?")->limit(1)->execute($this->revolutionslider);
			
			$strSlider = $objResult->title;
			
			$this->Template = new \BackendTemplate('be_wildcard');
			$this->Template->wildcard = '### REVOLUTION SLIDER ###'. '<p class="tl_gray">'.$strSlider.'</p>';;
			$this->Template->title = $this->headline;
			
			return $this->Template->parse();
		}
		
		return parent::generate();
	}
	
	/**
	 * Generate the module
	 */
	protected function compile()
	{
		if(!$this->revolutionslider)
		{
			return;
		}
		
		// create new slider instance and generate it
		$objSlider = \RevolutionSlider\Core\Factory::byId($this->revolutionslider);		
		
		// return if slider is obsolete
		if(!$objSlider)
		{
			return;
		}
		
		$objSlider->set('arrParent',$this->arrData);
		$arrCssID = deserialize($objSlider->get('cssID'));
		
		$arrClass = array();
		if(strlen($arrCssID[1]) > 0)
		{
			$arrClass = array_merge($arrClass,explode(' ',$arrCssID[1]));
		}
		
		if(!$GLOBALS['REVOLUTIONSLIDER']['isBundledVersion'])
		{
			$arrClass[] = $objSlider->get('sliderStyle');
		}
		
		if(count($arrClass) > 0)
		{
			$this->Template->sliderClass = trim(implode(' ', $arrClass));
		}
		$this->Template->slider = $objSlider->render();
	}


}