<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2013, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		revolutionslider
 * @link		http://contao.org
 */

/**
 * Back end modules
 */
array_insert($GLOBALS['BE_MOD']['content'], count($GLOBALS['BE_MOD']['content']), array
(
	'revolutionslider' => array
	(
		'tables' 		=> array('tl_revolutionslider','tl_revolutionslider_slides','tl_content'),
		'icon'   		=> 'system/modules/revolutionslider/assets/img/icon.gif',
	)
));

/**
 * Content elements
 */
$GLOBALS['TL_CTE']['revolutionslider_node'] = array
(
	'revolutionslider' 			=> 'RevolutionSlider\Frontend\ContentRevolutionSlider',
	'revolutionslider_video'	=> 'RevolutionSlider\Frontend\ContentRevolutionSliderVideo'
);

/**
 * Hooks
 */
$GLOBALS['TL_HOOKS']['replaceInsertTags'][] 			= array('RevolutionSlider\Core\InsertTags', 'replaceTags');

/**
 * Add permissions
 */
$GLOBALS['TL_PERMISSIONS'][] = 'revolutionsliders';
$GLOBALS['TL_PERMISSIONS'][] = 'revolutionslidersp';
$GLOBALS['TL_PERMISSIONS'][] = 'revolutionslider_slides';
$GLOBALS['TL_PERMISSIONS'][] = 'revolutionslider_slidesp';

/**
 * Globals
 */
$GLOBALS['REVOLUTIONSLIDER']['isBundledVersion']		= true;		// just toggles between a couple features
$GLOBALS['REVOLUTIONSLIDER']['cteIgnoreList'] 			= array();	// custom ignore list
$GLOBALS['REVOLUTIONSLIDER']['minifyScript'] 			= false;	// minify the script output in page head
$GLOBALS['REVOLUTIONSLIDER']['TRANSITIONS']				= array();	// add more transitions
$GLOBALS['REVOLUTIONSLIDER']['EASINGS']					= array();	// add more easing equations
$GLOBALS['REVOLUTIONSLIDER']['ANIMATIONS']['START']		= array();	// add more animation classes
$GLOBALS['REVOLUTIONSLIDER']['ANIMATIONS']['END']		= array();	// add more animation classes

// path to rs files
$upload_path = 'files';
if(strlen($GLOBALS['TL_CONFIG']['uploadPath']) > 0)
{
	$upload_path = $GLOBALS['TL_CONFIG']['uploadPath'];
}

$GLOBALS['REVOLUTIONSLIDER']['rs_plugin']				= $upload_path . '/cto_layout/scripts/rs-plugin'; 
$GLOBALS['REVOLUTIONSLIDER']['rs_js'] 					= $upload_path . '/cto_layout/scripts/rs-plugin/js/jquery.themepunch.revolution.min.js';
$GLOBALS['REVOLUTIONSLIDER']['rs_css']					= $upload_path . '/cto_layout/scripts/rs-plugin/css/settings.css';
$GLOBALS['REVOLUTIONSLIDER']['css'] 					= 'system/modules/revolutionslider/assets/css/styles.css';
