<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2013, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		revolutionslider
 * @link		http://contao.org
 */

$GLOBALS['TL_DCA']['tl_content']['config']['onload_callback'][] = array('RevolutionSlider\Backend\TableContent', 'modifyPalettes');	
$GLOBALS['TL_DCA']['tl_content']['config']['onsubmit_callback'][] = array('RevolutionSlider\Backend\TableContent', 'updateSliderRecord');	

/**
 * Palettes
 */
$GLOBALS['TL_DCA']['tl_content']['palettes']['revolutionslider'] = '{type_legend},type,headline;{select_legend},revolutionslider;{protected_legend:hide},protected;{expert_legend:hide},guests,invisible,cssID,space';
$GLOBALS['TL_DCA']['tl_content']['palettes']['revolutionslider_video'] = '{type_legend},type,headline;{select_legend},revolutionslider_videoType,multiSRC,url,revolutionslider_data_autoplay,revolutionslider_data_nextslideatend;{protected_legend:hide},protected;{expert_legend:hide},guests,invisible,cssID,space';

/**
 * Dynamically add the permission check and parent table
 */
if (\Input::getInstance()->get('do') == 'revolutionslider' && \Input::get('table') == 'tl_content')
{
	$GLOBALS['TL_DCA']['tl_content']['config']['ptable'] = 'tl_revolutionslider_slides';
	$GLOBALS['TL_DCA']['tl_content']['config']['onload_callback'][] = array('RevolutionSlider\Backend\TableContent', 'checkPermission');
	
	// remove revolutionslider from cte list to avoid adding a rs as content
	unset($GLOBALS['TL_CTE']['revolutionslider_node']['revolutionslider']);
	
	// remove cte from selection
	if($GLOBALS['REVOLUTIONSLIDER']['isBundledVersion'])
	{
		$arrAllowedCte = array('headline','text','image','hyperlink','revolutionslider_video');
		$arrAllowedIncludes = array();
		
		$arrAllowed = array_merge($arrAllowedCte,$arrAllowedIncludes);
		foreach($GLOBALS['TL_CTE'] as $node => $arrCte)
		{
			foreach($arrCte as $type => $class)
			{
				if(!in_array($type, $arrAllowed))
				{
					unset($GLOBALS['TL_CTE'][$node][$type]);
				}
			}
			
		}
	}
	
	// add slider palette on top of all available content elements
	foreach($GLOBALS['TL_DCA']['tl_content']['palettes'] as $cteType => $palette)
	{
		if( in_array($cteType, array('__selector__','revolutionslider')) || in_array($cteType, $GLOBALS['REVOLUTIONSLIDER']['cteIgnoreList']) )
		{
			continue;
		}
		
		$GLOBALS['TL_DCA']['tl_content']['palettes'][$cteType] = '{slide_legend},revolutionslider_data_easing,revolutionslider_data_speed,revolutionslider_data_position,revolutionslider_data_start,revolutionslider_data_animation_start,revolutionslider_data_animation_end,revolutionslider_data_linktoslide;'.$palette;
	}
}
else
{
	if(TL_MODE == 'BE')
	{
		// dont show the video cte outside the revolution slider backend
		unset($GLOBALS['TL_CTE']['revolutionslider_node']['revolutionslider_video']);
	}
}
	
/**
 * Fields
 */
$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider'],
	'exclude'                 => true,
	'inputType'               => 'radio',
	'options_callback'		  => array('RevolutionSlider\Backend\TableContent','getSliders'),
	'eval'                    => array('tl_class'=>'clr w50','insertBlankOption'=>true),
	'sql'					  =>  "varchar(64) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_easing'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_easing'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options_callback'		  => array('RevolutionSlider\Core\RevolutionSlider','getTransitionEasings'),
	'eval'                    => array('tl_class'=>'clr w50','chosen'=>true),
	'sql'					  =>  "varchar(64) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_speed'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_speed'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('tl_class'=>'w50'),
	'sql'					  =>  "varchar(16) NOT NULL default '0.5'",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_start'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_start'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'default'				  => 0,
	'eval'                    => array('tl_class'=>'w50'),
	'sql'					  =>  "varchar(16) NOT NULL default '0'",
);
	
$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_animation_start'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_animation_start'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options_callback'		  => array('RevolutionSlider\Core\RevolutionSlider','getStartAnimationClasses'),
	'reference'				  => $GLOBALS['TL_LANG']['revolutionSliderAnimationClasses'],
	'eval'                    => array('tl_class'=>'w50','chosen'=>true),
	'sql'					  =>  "varchar(16) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_animation_end'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_animation_end'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options_callback'		  => array('RevolutionSlider\Core\RevolutionSlider','getEndAnimationClasses'),
	'reference'				  => $GLOBALS['TL_LANG']['revolutionSliderAnimationClasses'],
	'eval'                    => array('tl_class'=>'w50','chosen'=>true),
	'sql'					  =>  "varchar(16) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_position'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_position'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('multiple'=>true, 'size'=>2, 'tl_class'=>'w50'),
	'sql'					  =>  "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_linktoslide'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_linktoslide'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options_callback'		  => array('RevolutionSlider\Backend\TableContent','getSlides'),
	'eval'                    => array('includeBlankOption'=>true,'tl_class'=>'w50'),
	'sql'					  =>  "varchar(16) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_autoplay'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_autoplay'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>''),
	'sql'					  =>  "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_nextslideatend'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_nextslideatend'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>''),
	'sql'					  =>  "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_videoType'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_videoType'],
	'exclude'                 => true,
	'inputType'               => 'radio',
	#'options'				  => array('local','youtube','vimeo'),
	'options'				  => array('local','external'),
	'reference'				  => $GLOBALS['TL_LANG']['tl_content']['revolutionslider_videoType'],
	'eval'                    => array('submitOnChange'=>true,'tl_class'=>''),
	'sql'					  =>  "varchar(32) NOT NULL default ''",
);

